bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: dd and closed stderr


From: Eric Blake
Subject: Re: dd and closed stderr
Date: Fri, 28 Aug 2009 17:05:53 +0000 (UTC)
User-agent: Loom/3.14 (http://gmane.org/)

Eric Blake <ebb9 <at> byu.net> writes:
>    due to their running on a kernel older than what was implied by headers
>    and libraries tested at configure time.

This part of NEWS describes a fix to a regression in 7.5.

> 
> +  dd now returns non-zero status if it encountered a write error while
> +  printing a summary to stderr.
> +

I've traced this to a regression introduced in 6.11:
https://bugzilla.redhat.com/show_bug.cgi?id=436368
http://git.savannah.gnu.org/cgit/coreutils.git/commit/?id=381e69ea

> For consistency with most of the shell code in coreutils,
> please elide double quotes in simple shell variable assignments:
> 
> p=$abs_top_builddir
> 
> Hmm... I see that close-stdout did it the same way.
> You're welcome to adjust that one, too.

OK, here's my updated series.


>From 7a2543e009956fa888ecc8d9f92d2fa10d7d52aa Mon Sep 17 00:00:00 2001
From: Eric Blake <address@hidden>
Date: Fri, 28 Aug 2009 10:59:16 -0600
Subject: [PATCH 1/2] dd: detect closed stderr

* src/dd.c (maybe_close_stdout): Always flush stderr; regression
introduced in commit 381e69ea.
* tests/misc/close-stdout (p): Use consistent style.
* tests/dd/stderr: New test, borrowing from misc/close-stdout.
* tests/Makefile.am (TESTS): Run it.
* NEWS: Mention this.
---
 NEWS                    |    5 ++++
 src/dd.c                |    7 +++++-
 tests/Makefile.am       |    1 +
 tests/dd/stderr         |   48 +++++++++++++++++++++++++++++++++++++++++++++++
 tests/misc/close-stdout |    2 +-
 5 files changed, 61 insertions(+), 2 deletions(-)
 create mode 100755 tests/dd/stderr

diff --git a/NEWS b/NEWS
index c125b31..c3b2e98 100644
--- a/NEWS
+++ b/NEWS
@@ -7,6 +7,11 @@ GNU coreutils NEWS                                    -*- 
outline -*-
   cp, mv now ignore failure to preserve a symlink time stamp, when it is
   due to their running on a kernel older than what was implied by headers
   and libraries tested at configure time.
+  [bug introduced in coreutils-7.5]
+
+  dd now returns non-zero status if it encountered a write error while
+  printing a summary to stderr.
+  [bug introduced in coreutils-6.11]


 * Noteworthy changes in release 7.5 (2009-08-20) [stable]
diff --git a/src/dd.c b/src/dd.c
index dc15cfd..d2f566e 100644
--- a/src/dd.c
+++ b/src/dd.c
@@ -25,6 +25,7 @@
 #include <getopt.h>

 #include "system.h"
+#include "close-stream.h"
 #include "error.h"
 #include "fd-reopen.h"
 #include "gethrxtime.h"
@@ -444,12 +445,16 @@ static bool close_stdout_required = true;
    close_stdout function call "fclose (stdout)" would result in a
    harmless failure of the close syscall (with errno EBADF).
    This function serves solely to avoid the unnecessary close_stdout
-   call, once parse_long_options has succeeded.  */
+   call, once parse_long_options has succeeded.
+   Meanwhile, we guarantee that the standard error stream is flushed,
+   by inlining the last half of close_stdout as needed.  */
 static void
 maybe_close_stdout (void)
 {
   if (close_stdout_required)
     close_stdout ();
+  else if (close_stream (stderr) != 0)
+    _exit (EXIT_FAILURE);
 }

 void
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 6ad6133..c88dd9c 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -305,6 +305,7 @@ TESTS =                                             \
   dd/skip-seek                                 \
   dd/skip-seek2                                        \
   dd/skip-seek-past-file                       \
+  dd/stderr                                    \
   dd/unblock-sync                              \
   df/total-verify                              \
   du/2g                                                \
diff --git a/tests/dd/stderr b/tests/dd/stderr
new file mode 100755
index 0000000..11dadb6
--- /dev/null
+++ b/tests/dd/stderr
@@ -0,0 +1,48 @@
+#!/bin/sh
+# Ensure dd recognizes failure to write to stderr.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  dd --version
+fi
+
+. $srcdir/test-lib.sh
+
+p=$abs_top_builddir
+
+fail=0
+
+# Ensure this exits successfully, even though stderr is closed,
+# because it generates no stderr output.
+dd --help >/dev/null 2>&- || fail=1
+
+# If 2>&- works, ensure this fails, because stderr is closed and it
+# *does* generate output.  2>&- apparently does not work in HP-UX 11.23.
+# This test is ineffective unless /dev/stderr also works.
+# This exposes a failure present in 6.11 through 7.5.
+if "$p/src/test" -w /dev/stderr 2>/dev/null &&
+   "$p/src/test" ! -w /dev/stderr 2>&-; then
+  echo | dd 2>&- && fail=1
+fi
+
+# Likewise for /dev/full, if /dev/full works.
+if test -w /dev/full && test -c /dev/full; then
+  echo | dd 2>/dev/full && fail=1
+fi
+
+Exit $fail
diff --git a/tests/misc/close-stdout b/tests/misc/close-stdout
index d5fdbb9..fe911d8 100755
--- a/tests/misc/close-stdout
+++ b/tests/misc/close-stdout
@@ -24,7 +24,7 @@ fi

 . $srcdir/test-lib.sh

-p="$abs_top_builddir"
+p=$abs_top_builddir

 fail=0

-- 
1.6.3.2


>From 37e1617204c154d56f2a44365b04f0bb8bce87e1 Mon Sep 17 00:00:00 2001
From: Eric Blake <address@hidden>
Date: Fri, 28 Aug 2009 11:03:05 -0600
Subject: [PATCH 2/2] build: avoid unused variable warnings on cygwin

* src/copy.c (clone_file, copy_attr_by_fd, copy_attr_by_name):
Mark up unused variables.
* src/remove.c (dirent_inode_sort_may_be_useful): Likewise.
---
 src/copy.c   |   14 ++++++++++----
 src/remove.c |    5 ++++-
 2 files changed, 14 insertions(+), 5 deletions(-)

diff --git a/src/copy.c b/src/copy.c
index 238764a..5f84f7e 100644
--- a/src/copy.c
+++ b/src/copy.c
@@ -149,6 +149,8 @@ clone_file (int dest_fd, int src_fd)
 # define BTRFS_IOC_CLONE _IOW (BTRFS_IOCTL_MAGIC, 9, int)
   return ioctl (dest_fd, BTRFS_IOC_CLONE, src_fd);
 #else
+  (void) dest_fd;
+  (void) src_fd;
   errno = ENOTSUP;
   return -1;
 #endif
@@ -251,15 +253,19 @@ copy_attr_by_name (char const *src_path, char const 
*dst_path,
 #else /* USE_XATTR */

 static bool
-copy_attr_by_fd (char const *src_path, int src_fd,
-                 char const *dst_path, int dst_fd, const struct cp_options *x)
+copy_attr_by_fd (char const *src_path ATTRIBUTE_UNUSED,
+                 int src_fd ATTRIBUTE_UNUSED,
+                 char const *dst_path ATTRIBUTE_UNUSED,
+                 int dst_fd ATTRIBUTE_UNUSED,
+                 const struct cp_options *x ATTRIBUTE_UNUSED)
 {
   return true;
 }

 static bool
-copy_attr_by_name (char const *src_path, char const *dst_path,
-                   const struct cp_options *x)
+copy_attr_by_name (char const *src_path ATTRIBUTE_UNUSED,
+                   char const *dst_path ATTRIBUTE_UNUSED,
+                   const struct cp_options *x ATTRIBUTE_UNUSED)
 {
   return true;
 }
diff --git a/src/remove.c b/src/remove.c
index 6c8613b..2c4a178 100644
--- a/src/remove.c
+++ b/src/remove.c
@@ -1311,7 +1311,10 @@ dirent_inode_sort_may_be_useful (int dir_fd)
     }
 }
 # else /* !HAVE_STRUCT_STATFS_F_TYPE */
-static bool dirent_inode_sort_may_be_useful (int dir_fd) { return true; }
+static bool dirent_inode_sort_may_be_useful (int dir_fd ATTRIBUTE_UNUSED)
+{
+  return true;
+}
 # endif /* !HAVE_STRUCT_STATFS_F_TYPE */
 #endif /* HAVE_STRUCT_DIRENT_D_TYPE */

-- 
1.6.3.2







reply via email to

[Prev in Thread] Current Thread [Next in Thread]